## qcoro 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
set(qcoro_VERSION 0.4.0)
set(qcoro_SOVERSION 0)
project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(GNUInstallDirs)
include(CTest)
include(FeatureSummary)

# Custom includes
include(GenerateHeaders)
include(AddQCoroLibrary)

#-----------------------------------------------------------#
# Options
#-----------------------------------------------------------#

option(QCORO_BUILD_EXAMPLES "Build examples" ON)
add_feature_info(Examples QCORO_BUILD_EXAMPLES "Build examples")
option(QCORO_ENABLE_ASAN "Build with AddressSanitizer" OFF)
add_feature_info(Asan QCORO_ENABLE_ASAN "Build with AddressSanitizer")

if(WIN32 OR APPLE OR ANDROID)
    option(QCORO_WITH_QTDBUS "Build QtDBus support" OFF)
else()
    option(QCORO_WITH_QTDBUS "Build QtDBus support" ON)
endif()
add_feature_info(QtDBus QCORO_WITH_QTDBUS "Build QtDBus support")
option(QCORO_WITH_QTNETWORK "Build QtNetwork support" ON)
add_feature_info(QtNetwork QCORO_WITH_QTNETWORK "Build QtNetwork support")

#-----------------------------------------------------------#
# Compiler Settings
#-----------------------------------------------------------#

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_AUTOMOC ON)

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /WX")
    # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
    # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5054 /wd4127")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror -pedantic")
endif()

if (QCORO_ENABLE_ASAN)
    if (MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
    endif()
endif()

include(qcoro/QCoroMacros.cmake)
qcoro_enable_coroutines()

#-----------------------------------------------------------#
# Dependencies
#-----------------------------------------------------------#

find_package(Threads REQUIRED)

set(REQUIRED_QT_COMPONENTS Core)
if (QCORO_WITH_QTDBUS)
    list(APPEND REQUIRED_QT_COMPONENTS DBus)
endif()
if (QCORO_WITH_QTNETWORK)
    list(APPEND REQUIRED_QT_COMPONENTS Network)
endif()
if (QCORO_BUILD_EXAMPLES)
    list(APPEND REQUIRED_QT_COMPONENTS Widgets Concurrent)
endif()
if (BUILD_TESTING)
    list(APPEND REQUIRED_QT_COMPONENTS Test Concurrent)
endif()

set(MIN_REQUIRED_QT5_VERSION "5.12")
# 6.1.2 fixes QTBUG-93270 which prevents compiling against Qt6 with C++20 enabled
set(MIN_REQUIRED_QT6_VERSION "6.1.2")


if (NOT USE_QT_VERSION)
    # FIXME: find_package(QT NAMES Qt6 Qt5 ...) seems to prefer Qt5 on my system
    find_package(Qt6 ${MIN_REQUIRED_QT6_VERSION} COMPONENTS ${REQUIRED_QT_COMPONENTS})
    if (NOT Qt6_FOUND)
        find_package(Qt5 ${MIN_REQUIRED_QT5_VERSION} COMPONENTS ${REQUIRED_QT_COMPONENTS} REQUIRED)
        set(QT_VERSION_MAJOR 5)
    else()
        set(QT_VERSION_MAJOR 6)
    endif()
else()
    find_package(Qt${USE_QT_VERSION} ${MIN_REQUIRED_QT${USE_QT_VERSION}_VERSION}
                 COMPONENTS ${REQUIRED_QT_COMPONENTS} REQUIRED)
    set(QT_VERSION_MAJOR ${USE_QT_VERSION})
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

#-----------------------------------------------------------#
# Definitions
#-----------------------------------------------------------#

set(QCORO_TARGET_PREFIX "QCoro${QT_VERSION_MAJOR}")
set(QCORO_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/qcoro${QT_VERSION_MAJOR}")

#-----------------------------------------------------------#
# Sources
#-----------------------------------------------------------#

set(QCORO_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_subdirectory(qcoro)
if (QCORO_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()
if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

#-----------------------------------------------------------#
# Installation
#-----------------------------------------------------------#

include(CMakePackageConfigHelpers)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro
    COMPONENT Devel
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/QCoroConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}"
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}ConfigVersion.cmake"
    VERSION ${qcoro_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}Config.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}ConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}"
    COMPONENT Devel
)

#-----------------------------------------------------------#
# Summary
#-----------------------------------------------------------#

feature_summary(FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)

=== requirements.txt ===
setuptools
wheel
mkdocs
mkdocs-material
mkdocs-section-index
mkdocs-include-markdown-plugin
mkdocs-macros-plugin

=== qcoro/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Coro
    INTERFACE
    INCLUDEDIR Coro
    CAMELCASE_HEADERS
        Task
        QCoro
    HEADERS
        concepts_p.h
        coroutine.h
        macros_p.h
        task.h
        waitoperationbase_p.h
    QT_LINK_LIBRARIES
        INTERFACE Core
)

# Install the extra macros file
install(
    FILES "QCoroMacros.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QCORO_TARGET_PREFIX}Coro/"
)

############################

add_subdirectory(core)

if (QCORO_WITH_QTDBUS)
    add_subdirectory(dbus)
endif()

if (QCORO_WITH_QTNETWORK)
    add_subdirectory(network)
endif()

=== tests/CMakeLists.txt ===
include(CMakeParseArguments)

add_library(qcoro_test STATIC testobject.cpp)
target_link_libraries(qcoro_test PUBLIC
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
)

if (QCORO_WITH_QTDBUS)
    add_executable(testdbusserver EXCLUDE_FROM_ALL testdbusserver.cpp)
    target_link_libraries(testdbusserver
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::DBus
    )

    set(qcoro_test_dbus_SRCS)
    if (${QT_VERSION_MAJOR} EQUAL 5)
        qt5_add_dbus_interface(qcoro_test_dbus_SRCS cz.dvratil.qcorodbustest.xml qcorodbustestinterface)
    else()
        qt_add_dbus_interface(qcoro_test_dbus_SRCS cz.dvratil.qcorodbustest.xml qcorodbustestinterface)
    endif()
    add_library(qcoro_test_dbus OBJECT ${qcoro_test_dbus_SRCS})
    target_link_libraries(qcoro_test_dbus PUBLIC
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::DBus
    )
endif()

function(qcoro_add_test _name)
    set(options)
    set(oneValueArgs)
    set(multiValueAgs LINK_LIBRARIES)
    cmake_parse_arguments(TEST "${options}" "${oneValueArgs}" "${multiValueAgs}" ${ARGN})
    add_executable(test-${_name} ${_name}.cpp)
    target_link_libraries(
        test-${_name}
        qcoro_test
        QCoro${QT_VERSION_MAJOR}Core
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Test
        ${TEST_LINK_LIBRARIES}
        Threads::Threads
    )
    add_test(NAME test-${_name} COMMAND test-${_name})
endfunction()

function(qcoro_add_network_test _name)
    set(options)
    set(oneValueArgs)
    set(multiValueAgs LINK_LIBRARIES)
    cmake_parse_arguments(TEST "${options}" "${oneValueArgs}" "${multiValueAgs}" ${ARGN})
    add_executable(test-${_name} ${_name}.cpp)
    target_link_libraries(
        test-${_name}
        QCoro${QT_VERSION_MAJOR}Network
        qcoro_test
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Test
        Qt${QT_VERSION_MAJOR}::Network
        Threads::Threads
        ${TEST_LINK_LIBRARIES}
    )
    add_test(NAME test-${_name} COMMAND test-${_name})
endfunction()

function(qcoro_add_dbus_test _name)
    set(options)
    set(oneValueArgs)
    set(multiValueAgs LINK_LIBRARIES)
    cmake_parse_arguments(TEST "${options}" "${oneValueArgs}" "${multiValueAgs}" ${ARGN})
    set(test_SRCS ${_name}.cpp)
    add_executable(test-${_name} ${test_SRCS})
    add_dependencies(test-${_name} testdbusserver qcoro_test_dbus)
    target_link_libraries(
        test-${_name}
        QCoro${QT_VERSION_MAJOR}DBus
        qcoro_test
        qcoro_test_dbus
        ${TEST_LINK_LIBRARIES}
    )
    target_include_directories(test-${_name} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
    target_compile_definitions(test-${_name} PRIVATE TESTDBUSSERVER_EXECUTABLE=\"$<TARGET_FILE:testdbusserver>\")
    if (APPLE)
        # On MacOS dbus-launch doesn't work, so we rely on the session dbus running
        add_test(NAME test-${_name} COMMAND test-${_name})
    else()
        add_test(NAME test-${_name} COMMAND dbus-launch $<TARGET_FILE:test-${_name}>)
    endif()
endfunction()



qcoro_add_test(qtimer)
qcoro_add_test(qcoroprocess)
qcoro_add_test(qcorosignal)
qcoro_add_test(task)
qcoro_add_test(testconstraints)
qcoro_add_test(qfuture LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Concurrent)

if (QCORO_WITH_QTDBUS)
    qcoro_add_dbus_test(qdbuspendingcall)
    qcoro_add_dbus_test(qdbuspendingreply)
endif()

if (QCORO_WITH_QTNETWORK)
    qcoro_add_network_test(qcorolocalsocket)
    qcoro_add_network_test(qcoroabstractsocket)
    qcoro_add_network_test(qcoronetworkreply)
    qcoro_add_network_test(qcorotcpserver)

    # Tests for test utilities
    qcoro_add_network_test(testhttpserver)
endif()

=== examples/future/CMakeLists.txt ===
add_executable(future-example main.cpp)
target_link_libraries(future-example
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Concurrent
)

=== examples/iodevice/CMakeLists.txt ===
add_executable(iodevice-example main.cpp)
target_link_libraries(iodevice-example
    QCoro${QT_VERSION_MAJOR}Core
    QCoro${QT_VERSION_MAJOR}Network
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Network
)

=== qcoro/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Core
    INCLUDEDIR Core
    SOURCES
        qcoroiodevice.cpp
        qcoroprocess.cpp
        qcorotimer.cpp
    CAMELCASE_HEADERS
        QCoroCore
        QCoroIODevice
        QCoroProcess
        QCoroSignal
        QCoroTimer
        QCoroFuture
    QT_LINK_LIBRARIES
        PUBLIC Core
)

=== qcoro/dbus/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME DBus
    SOURCES
        qcorodbuspendingcall.cpp
    CAMELCASE_HEADERS
        QCoroDBus
        QCoroDBusPendingCall
        QCoroDBusPendingReply
    QCORO_LINK_LIBRARIES
        PUBLIC Core
    QT_LINK_LIBRARIES
        PUBLIC DBus
)

=== qcoro/network/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Network
    SOURCES
        qcoroabstractsocket.cpp
        qcorolocalsocket.cpp
        qcoronetworkreply.cpp
        qcorotcpserver.cpp
    CAMELCASE_HEADERS
        QCoroNetwork
        QCoroAbstractSocket
        QCoroLocalSocket
        QCoroNetworkReply
        QCoroTcpServer
    QCORO_LINK_LIBRARIES
        PUBLIC Core
    QT_LINK_LIBRARIES
        PUBLIC Network
)

=== debian/changelog ===
qcoro (0.4.0-4ubuntu1) jammy; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Wed, 16 Mar 2022 11:07:03 +0000

qcoro (0.4.0-4) unstable; urgency=medium

  * Package tests are too flaky - do not let them fail the package
    build.
  * Add Multi-Arch hints for qcoro-*-dev.

 -- Sandro Knauß <hefee@debian.org>  Mon, 07 Mar 2022 11:47:13 +0100

qcoro (0.4.0-3ubuntu1) jammy; urgency=medium

  * Do not run tests at build time. Flaky.
  * Update synbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Feb 2022 20:56:20 +0000

qcoro (0.4.0-3) unstable; urgency=medium

  [ Sandro Knauß ]
  * Update symbols from buildds for 0.4.0

 -- Sandro Knauß <hefee@debian.org>  Fri, 25 Feb 2022 20:32:10 +0100

qcoro (0.4.0-2) unstable; urgency=medium

  [ Sandro Knauß ]
  * Add dependencies on dev packages to qtX-dev packages.
  * Set correct Debian maintainer information.
  * Add Multi-Arch hints.

 -- Sandro Knauß <hefee@debian.org>  Fri, 25 Feb 2022 20:22:34 +0100

qcoro (0.4.0-1) unstable; urgency=medium

  * Initial release for Debian (Closes: #1006210).

 -- Sandro Knauß <hefee@debian.org>  Mon, 21 Feb 2022 16:18:13 +0100

=== debian/control ===
Source: qcoro
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: cmake (>= 3.19~),
               debhelper-compat (= 13),
               dbus-x11,
               pkg-kde-tools,
               qtbase5-dev (>= 5.15.0~),
               qt6-base-dev (>= 6.1.2~),
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
Homepage: https://qcoro.dvratil.cz/
Rules-Requires-Root: no

Package: libqcoro5core0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the core library.

Package: libqcoro6core0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the core library.

Package: libqcoro5dbus0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the DBus library.

Package: libqcoro6dbus0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the DBus library.

Package: libqcoro5network0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the network library.

Package: libqcoro6network0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the network library.

Package: qcoro-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: doc
Description: C++20 coroutines for Qt5 - documentation & examples
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt actions.
 .
 This package has the examples and documentation files.

Package: qcoro-qt5-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro5core0 (= ${binary:Version}),
         libqcoro5dbus0 (= ${binary:Version}),
         libqcoro5network0 (= ${binary:Version}),
         qtbase5-dev (>= 5.15.0~),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt5 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This package has the development files.

Package: qcoro-qt6-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro6core0 (= ${binary:Version}),
         libqcoro6dbus0 (= ${binary:Version}),
         libqcoro6network0 (= ${binary:Version}),
         qt6-base-dev (>= 6.1.2~),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt6 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This package has the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build-Qt6

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_QT_VERSION=5 -DBUILD_SHARED_LIBS=ON
	dh_auto_configure --builddirectory=build-Qt6  -- -DUSE_QT_VERSION=6 -DBUILD_SHARED_LIBS=ON

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=build-Qt6

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=build-Qt6

override_dh_install-indep:
	dh_install
	rm debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/changelog.md
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/about
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/overrides

override_dh_auto_test:
	- dh_auto_test --no-parallel

=== debian/watch ===
version=4

https://github.com/danvratil/qcoro/releases /danvratil/qcoro/archive/refs/tags/v([\d.]+).tar.gz

## qcoro 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.19)
-set(qcoro_VERSION 0.4.0)
+cmake_minimum_required(VERSION 3.18.4)
+set(qcoro_VERSION 0.6.0)
 set(qcoro_SOVERSION 0)
 project(qcoro LANGUAGES CXX VERSION ${qcoro_VERSION})
 
@@ -8,10 +8,6 @@
 include(GNUInstallDirs)
 include(CTest)
 include(FeatureSummary)
-
-# Custom includes
-include(GenerateHeaders)
-include(AddQCoroLibrary)
 
 #-----------------------------------------------------------#
 # Options
@@ -21,6 +17,7 @@
 add_feature_info(Examples QCORO_BUILD_EXAMPLES "Build examples")
 option(QCORO_ENABLE_ASAN "Build with AddressSanitizer" OFF)
 add_feature_info(Asan QCORO_ENABLE_ASAN "Build with AddressSanitizer")
+option(QCORO_DISABLE_DEPRECATED_TASK_H "Disable deprecated task.h header" OFF)
 
 if(WIN32 OR APPLE OR ANDROID)
     option(QCORO_WITH_QTDBUS "Build QtDBus support" OFF)
@@ -30,39 +27,17 @@
 add_feature_info(QtDBus QCORO_WITH_QTDBUS "Build QtDBus support")
 option(QCORO_WITH_QTNETWORK "Build QtNetwork support" ON)
 add_feature_info(QtNetwork QCORO_WITH_QTNETWORK "Build QtNetwork support")
-
-#-----------------------------------------------------------#
-# Compiler Settings
-#-----------------------------------------------------------#
-
-set(CMAKE_CXX_STANDARD 20)
-set(CMAKE_AUTOMOC ON)
-
-if (MSVC)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /WX")
-    # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
-    # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5054 /wd4127")
-else()
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror -pedantic")
-endif()
-
-if (QCORO_ENABLE_ASAN)
-    if (MSVC)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
-    else()
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
-    endif()
-endif()
-
-include(qcoro/QCoroMacros.cmake)
-qcoro_enable_coroutines()
+option(QCORO_WITH_QTWEBSOCKETS "Build QtWebSockets support" ON)
+add_feature_info(QtWebSockets QCORO_WITH_QTWEBSOCKETS "Build QtWebSockets support")
 
 #-----------------------------------------------------------#
 # Dependencies
 #-----------------------------------------------------------#
 
+set(THREADS_PREFER_PTHREAD_FLAG TRUE)
 find_package(Threads REQUIRED)
+
+include(cmake/CheckAtomic.cmake)
 
 set(REQUIRED_QT_COMPONENTS Core)
 if (QCORO_WITH_QTDBUS)
@@ -71,6 +46,9 @@
 if (QCORO_WITH_QTNETWORK)
     list(APPEND REQUIRED_QT_COMPONENTS Network)
 endif()
+if (QCORO_WITH_QTWEBSOCKETS)
+    list(APPEND REQUIRED_QT_COMPONENTS WebSockets)
+endif()
 if (QCORO_BUILD_EXAMPLES)
     list(APPEND REQUIRED_QT_COMPONENTS Widgets Concurrent)
 endif()
@@ -79,8 +57,7 @@
 endif()
 
 set(MIN_REQUIRED_QT5_VERSION "5.12")
-# 6.1.2 fixes QTBUG-93270 which prevents compiling against Qt6 with C++20 enabled
-set(MIN_REQUIRED_QT6_VERSION "6.1.2")
+set(MIN_REQUIRED_QT6_VERSION "6.2.0")
 
 
 if (NOT USE_QT_VERSION)
@@ -104,6 +81,69 @@
 )
 
 #-----------------------------------------------------------#
+# Compiler Settings
+#-----------------------------------------------------------#
+
+set(CMAKE_CXX_STANDARD 20)
+set(CMAKE_AUTOMOC ON)
+
+if (MSVC)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /WX")
+    # Disable warning C5054: "operator '&': deprecated between enumerations of different types" caused by QtWidgets/qsizepolicy.h
+    # Disable warning C4127: "conditional expression is constant" caused by QtCore/qiterable.h
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5054 /wd4127")
+
+    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+        # Explicitly enable exceptions support for clang-cl (it's only enabled by CMake when targeting the Windows-MSVC platform,
+        # see https://github.com/danvratil/qcoro/issues/90 for details)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
+    endif()
+else()
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Werror -pedantic")
+endif()
+
+if (QCORO_ENABLE_ASAN)
+    if (MSVC)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /INCREMENTAL:NO")
+        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
+        else()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
+        endif()
+    else()
+        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL "11.0.0")
+            # I tried my best, but there are crashes when combining asan and coroutines.
+            message(WARNING "ASAN not supported for Clang<=11.0")
+        else()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fsanitize-recover=address")
+        endif()
+    endif()
+endif()
+
+add_compile_definitions(
+    QT_NO_CAST_FROM_ASCII
+    QT_NO_CAST_TO_ASCII
+    QT_NO_URL_CAST_FROM_STRING
+    QT_NO_CAST_FROM_BYTEARRAY
+    QT_USE_STRINGBUILDER
+    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
+    QT_NO_KEYWORDS
+    QT_NO_FOREACH
+)
+if (NOT WIN32)
+    # strict iterators on MSVC only work when Qt itself is also built with them,
+    # which is not usually the case. Otherwise there are linking issues.
+    add_compile_definitions(QT_STRICT_ITERATORS)
+endif()
+
+include(qcoro/QCoroMacros.cmake)
+qcoro_enable_coroutines()
+
+include(cmake/CodeCoverage.cmake)
+add_code_coverage()
+add_code_coverage_all_targets(EXCLUDE "${CMAKE_BINARY_DIR}" tests/utils/*)
+
+#-----------------------------------------------------------#
 # Definitions
 #-----------------------------------------------------------#
 
@@ -160,5 +200,3 @@
 #-----------------------------------------------------------#
 
 feature_summary(FATAL_ON_MISSING_REQUIRED_PACKAGES WHAT ALL)
-
-

=== requirements.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 setuptools
 wheel
+pygments~=2.11.0
 mkdocs
 mkdocs-material
 mkdocs-section-index

=== qcoro/CMakeLists.txt ===
--- 
+++ 
@@ -2,21 +2,67 @@
 #
 # SPDX-License-Identifier: MIT
 
+# Custom includes
+include(GenerateHeaders)
+include(AddQCoroLibrary)
+
+include(CMakePackageConfigHelpers)
+
 add_qcoro_library(
     NAME Coro
     INTERFACE
+    NO_CMAKE_CONFIG
     INCLUDEDIR Coro
     CAMELCASE_HEADERS
-        Task
         QCoro
+        QCoroAsyncGenerator
+        QCoroFwd
+        QCoroGenerator
+        QCoroTask
     HEADERS
         concepts_p.h
         coroutine.h
         macros_p.h
-        task.h
         waitoperationbase_p.h
     QT_LINK_LIBRARIES
         INTERFACE Core
+)
+
+if (NOT QCORO_DISABLE_DEPRECATED_TASK_H)
+    # Install Task conditionally
+    generate_headers(
+        task_cc_HEADERS
+        HEADER_NAMES Task
+        OUTPUT_DIR QCoro
+        ORIGINAL_HEADERS_VAR task_lc_HEADERS
+    )
+
+    install(
+        FILES ${task_lc_HEADERS}
+        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro/
+        COMPONENT Devel
+    )
+    install(
+        FILES ${task_cc_HEADERS}
+        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/QCoro/
+        COMPONENT Devel
+    )
+endif()
+
+
+# The QCoroCoroConfig includes the QCoroMacros.cmake so we can't
+# use the standard file generated by add_qcoro_library.
+configure_package_config_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/QCoroCoroConfig.cmake.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}CoroConfig.cmake"
+    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}Coro
+    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
+)
+
+write_basic_package_version_file(
+    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}CoroConfigVersion.cmake"
+    VERSION ${qcoro_VERSION}
+    COMPATIBILITY SameMajorVersion
 )
 
 # Install the extra macros file
@@ -37,3 +83,6 @@
     add_subdirectory(network)
 endif()
 
+if (QCORO_WITH_QTWEBSOCKETS)
+    add_subdirectory(websockets)
+endif()

=== tests/CMakeLists.txt ===
add_subdirectory(testlibs)

include(CMakeParseArguments)

function(qcoro_add_test _name)
    set(options SKIP_ADD_TEST)
    set(oneValueArgs)
    set(multiValueAgs LINK_LIBRARIES)
    cmake_parse_arguments(TEST "${options}" "${oneValueArgs}" "${multiValueAgs}" ${ARGN})
    add_executable(test-${_name} ${_name}.cpp)
    target_link_libraries(
        test-${_name}
        PRIVATE
        qcoro_test
        QCoro${QT_VERSION_MAJOR}Core
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Test
        ${TEST_LINK_LIBRARIES}
        Threads::Threads
    )
    if (NOT TEST_SKIP_ADD_TEST)
        add_test(NAME test-${_name} COMMAND test-${_name})
    endif()
    target_code_coverage(test-${_name} AUTO ALL EXCLUDE "${CMAKE_BINARY_DIR}" "tests/testlibs/*")
endfunction()

function(qcoro_add_network_test _name)
    qcoro_add_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Network
        Qt${QT_VERSION_MAJOR}::Network
    )
    if(NOT HAVE_CXX_ATOMICS_WITHOUT_LIB)
        target_link_libraries(test-${_name} PRIVATE atomic)
    endif()
endfunction()

function(qcoro_add_dbus_test _name)
    qcoro_add_test(${_name} ${ARGN} SKIP_ADD_TEST)
    add_dependencies(test-${_name} testdbusserver qcoro_test_dbus)
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}DBus
        qcoro_test_dbus
    )
    target_compile_definitions(test-${_name} PRIVATE TESTDBUSSERVER_EXECUTABLE=\"$<TARGET_FILE:testdbusserver>\")
    if (APPLE)
        # On MacOS dbus-launch doesn't work, so we rely on the session dbus running
        add_test(NAME test-${_name} COMMAND test-${_name})
    else()
        add_test(NAME test-${_name} COMMAND dbus-launch $<TARGET_FILE:test-${_name}>)
    endif()
endfunction()

function(qcoro_add_websockets_test _name)
    qcoro_add_network_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}WebSockets
        Qt${QT_VERSION_MAJOR}::WebSockets
        qcoro_test_ws
    )
endfunction()


qcoro_add_test(qtimer)
qcoro_add_test(qcoroprocess)
qcoro_add_test(qcorosignal)
qcoro_add_test(qcorothread)
qcoro_add_test(qcorotask)
qcoro_add_test(testconstraints)
qcoro_add_test(qfuture LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Concurrent)
qcoro_add_test(qcorogenerator)
qcoro_add_test(qcoroasyncgenerator)

if (QCORO_WITH_QTDBUS)
    qcoro_add_dbus_test(qdbuspendingcall)
    qcoro_add_dbus_test(qdbuspendingreply)
endif()

if (QCORO_WITH_QTNETWORK)
    qcoro_add_network_test(qcorolocalsocket)
    qcoro_add_network_test(qcoroabstractsocket)
    qcoro_add_network_test(qcoronetworkreply)
    qcoro_add_network_test(qcorotcpserver)

    # Tests for test utilities
    qcoro_add_network_test(testhttpserver)
endif()

if (QCORO_WITH_QTWEBSOCKETS)
    qcoro_add_websockets_test(qcorowebsocket)
    qcoro_add_websockets_test(qcorowebsocketserver)
endif()

=== debian/changelog ===
qcoro (0.6.0-4ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Sun, 07 Aug 2022 08:07:21 +0100

qcoro (0.6.0-4) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit eba5ec31ba7a270df91986f9af94f688151da9e6 to use
    -Werror only in debug builds; patch
    upstream_Only-enable-Werror-and-related-flags-in-debug-mode-f.patch.
    (Closes: #1016282)
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Sun, 07 Aug 2022 07:45:15 +0200

qcoro (0.6.0-3ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Mon, 11 Jul 2022 06:16:17 +0100

qcoro (0.6.0-3) unstable; urgency=medium

  * Team upload.
  * Make the tests fatal again, as they seem to be stable with qcoro 0.6.0.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jul 2022 20:57:29 +0200

qcoro (0.6.0-2) unstable; urgency=medium

  * Team upload.
  * Enable the QtWebSockets support:
    - drop -DQCORO_WITH_QTWEBSOCKETS=OFF from the cmake arguments
    - add the libqt5websockets5-dev, and libqt6websockets6-dev build
      dependencies
    - add the libqcoro5websockets0, and libqcoro6websockets0 packages
    - add the libqt5websockets5-dev dependency to qcoro-qt5-dev
    - add the libqt6websockets6-dev deoendency to qcoro-qt6-dev

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jul 2022 12:44:29 +0200

qcoro (0.6.0-1ubuntu1) kinetic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Sun, 10 Jul 2022 11:22:45 +0100

qcoro (0.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - lower cmake to 3.18.4
  * Disable the QtWebSockets supports for now, as it requires adding new binary
    packages
    - pass -DQCORO_WITH_QTWEBSOCKETS=OFF to cmake
  * Bump Standards-Version to 4.6.1, no changes required.
  * Update symbols files.
  * Update lintian overrides.
  * CI: align to other KDE sources.

 -- Pino Toscano <pino@debian.org>  Sun, 10 Jul 2022 11:34:52 +0200

qcoro (0.5.1-1ubuntu1) kinetic; urgency=medium

  * Update symbols from Ubuntu build logs.

 -- Rik Mills <rikmills@kde.org>  Wed, 04 May 2022 17:33:40 +0100

qcoro (0.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - qcorosignal.diff: drop, fixed upstream

 -- Pino Toscano <pino@debian.org>  Thu, 28 Apr 2022 06:12:29 +0200

qcoro (0.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - upstream_Build-Check-if-libatomic-is-required.patch: drop, backported
      from upstream
  * Update the build dependencies according to the upstream build system:
    - bump qt6-base-dev to 6.2.0
  * Avoid a build failure with GCC 11; patch qcorosignal.diff.
  * Update install files.
  * Update symbols files.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Tue, 26 Apr 2022 07:16:54 +0200

qcoro (0.4.0-5) unstable; urgency=medium

  * Team upload.
  * Factorize the common cmake arguments in qt5/qt6 builds in a single
    variable.
  * Pass -DQCORO_BUILD_EXAMPLES=OFF to cmake to disable the build of examples,
    as nothing is done with them.
  * Remove the unused ${shlibs:Depends} substvar from qcoro-doc, qcoro-qt5-dev,
    and qcoro-qt6-dev.
  * Use execute_after_dh_auto_clean & xecute_after_dh_install-indep instead of
    manually calling dh_auto_clean & dh_install.
  * Backport upstream commit 312f2fca861b4c623481da58241a1139e013ef83 to link
    to the atomic library if needed on the architecture; patch
    upstream_Build-Check-if-libatomic-is-required.patch. (Closes: #1008615)
  * Run also the unit tests for the qt6 build in non-fatal mode.
  * Mark the dbus-x11 build dependency as !nocheck, as it is needed only during
    dh_auto_test.

 -- Pino Toscano <pino@debian.org>  Sat, 16 Apr 2022 13:10:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,18 @@
 Source: qcoro
 Section: libs
 Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
-Build-Depends: cmake (>= 3.19~),
+Build-Depends: cmake (>= 3.18.4~),
                debhelper-compat (= 13),
-               dbus-x11,
+               dbus-x11 <!nocheck>,
                pkg-kde-tools,
                qtbase5-dev (>= 5.15.0~),
-               qt6-base-dev (>= 6.1.2~),
-Standards-Version: 4.6.0
+               libqt5websockets5-dev (>= 5.15.0~),
+               qt6-base-dev (>= 6.2.0~),
+               libqt6websockets6-dev (>= 6.2.0~),
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
 Homepage: https://qcoro.dvratil.cz/
@@ -75,10 +78,30 @@
  .
  This is the network library.
 
+Package: libqcoro5websockets0
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: C++20 coroutines for Qt5 - WebSockets
+ QCoro is a C++ library that provide set of tools to make use of C++20
+ coroutines in connection with certain asynchronous Qt5 actions.
+ .
+ This is the web sockets library.
+
+Package: libqcoro6websockets0
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: C++20 coroutines for Qt6 - WebSockets
+ QCoro is a C++ library that provide set of tools to make use of C++20
+ coroutines in connection with certain asynchronous Qt6 actions.
+ .
+ This is the web sockets library.
+
 Package: qcoro-doc
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
 Section: doc
 Description: C++20 coroutines for Qt5 - documentation & examples
  QCoro is a C++ library that provide set of tools to make use of C++20
@@ -92,9 +115,10 @@
 Depends: libqcoro5core0 (= ${binary:Version}),
          libqcoro5dbus0 (= ${binary:Version}),
          libqcoro5network0 (= ${binary:Version}),
+         libqcoro5websockets0 (= ${binary:Version}),
          qtbase5-dev (>= 5.15.0~),
+         libqt5websockets5-dev (>= 5.15.0~),
          ${misc:Depends},
-         ${shlibs:Depends}
 Recommends: qcoro-doc
 Section: libdevel
 Description: C++20 coroutines for Qt5 - development
@@ -109,9 +133,10 @@
 Depends: libqcoro6core0 (= ${binary:Version}),
          libqcoro6dbus0 (= ${binary:Version}),
          libqcoro6network0 (= ${binary:Version}),
+         libqcoro6websockets0 (= ${binary:Version}),
          qt6-base-dev (>= 6.1.2~),
+         libqt6websockets6-dev (>= 6.2.0~),
          ${misc:Depends},
-         ${shlibs:Depends}
 Recommends: qcoro-doc
 Section: libdevel
 Description: C++20 coroutines for Qt6 - development

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_ARGS = -DBUILD_SHARED_LIBS=ON -DQCORO_BUILD_EXAMPLES=OFF

%:
	dh $@ --with pkgkde_symbolshelper

execute_after_dh_auto_clean:
	rm -rf build-Qt6

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_ARGS) -DUSE_QT_VERSION=5
	dh_auto_configure --builddirectory=build-Qt6 -- $(CMAKE_ARGS) -DUSE_QT_VERSION=6

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=build-Qt6

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=build-Qt6

execute_after_dh_install-indep:
	rm debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/changelog.md
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/about
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/overrides

override_dh_auto_test:
	dh_auto_test --no-parallel
	dh_auto_test --no-parallel --builddirectory=build-Qt6
